/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TurnoDAO;
import com.rjconsultores.ventaboletos.entidad.Turno;
import com.rjconsultores.ventaboletos.service.TurnoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("turnoService")
public class TurnoServiceImpl implements TurnoService {

    @Autowired
    private TurnoDAO turnoDAO;

    public List<Turno> obtenerTodos() {
        return turnoDAO.obtenerTodos();
    }

    public Turno obtenerID(Integer id) {
        return turnoDAO.obtenerID(id);
    }

    @Transactional
    public Turno suscribir(Turno entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return turnoDAO.suscribir(entidad);
    }

    @Transactional
    public Turno actualizacion(Turno entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return turnoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Turno entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        turnoDAO.actualizacion(entidad);
    }

    public List<Turno> buscar(String descturno) {
        return turnoDAO.buscar(descturno);
    }
}
